"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocExplorer = void 0;
var react_1 = __importStar(require("react"));
var graphql_1 = require("graphql");
var react_2 = require("@graphiql/react");
var FieldDoc_1 = __importDefault(require("./DocExplorer/FieldDoc"));
var SchemaDoc_1 = __importDefault(require("./DocExplorer/SchemaDoc"));
var SearchBox_1 = __importDefault(require("./DocExplorer/SearchBox"));
var SearchResults_1 = __importDefault(require("./DocExplorer/SearchResults"));
var TypeDoc_1 = __importDefault(require("./DocExplorer/TypeDoc"));
exports.DocExplorer = react_1.memo(function DocExplorer(_a) {
    var children = _a.children, schema = _a.schema, schemaErrors = _a.schemaErrors;
    var explorerContext = react_2.useExplorerNavStack();
    if (!explorerContext) {
        throw new Error('Tried to render the `DocExplorer` component without the necessary context. Make sure that the `ExplorerContextProvider` from `@graphiql/react` is rendered higher in the tree.');
    }
    var explorerNavStack = explorerContext.explorerNavStack, pop = explorerContext.pop, push = explorerContext.push, showSearch = explorerContext.showSearch;
    var navItem = explorerNavStack[explorerNavStack.length - 1];
    function handleClickType(type) {
        push({ name: type.name, def: type });
    }
    function handleClickField(field) {
        push({ name: field.name, def: field });
    }
    var content;
    if (schemaErrors) {
        content = react_1.default.createElement("div", { className: "error-container" }, "Error fetching schema");
    }
    else if (schema === undefined) {
        content = (react_1.default.createElement("div", { className: "spinner-container" },
            react_1.default.createElement("div", { className: "spinner" })));
    }
    else if (!schema) {
        content = react_1.default.createElement("div", { className: "error-container" }, "No Schema Available");
    }
    else if (navItem.search) {
        content = (react_1.default.createElement(SearchResults_1.default, { searchValue: navItem.search, withinType: navItem.def, schema: schema, onClickType: handleClickType, onClickField: handleClickField }));
    }
    else if (explorerNavStack.length === 1) {
        content = react_1.default.createElement(SchemaDoc_1.default, { schema: schema, onClickType: handleClickType });
    }
    else if (graphql_1.isType(navItem.def)) {
        content = (react_1.default.createElement(TypeDoc_1.default, { schema: schema, type: navItem.def, onClickType: handleClickType, onClickField: handleClickField }));
    }
    else {
        content = react_1.default.createElement(FieldDoc_1.default, { field: navItem.def, onClickType: handleClickType });
    }
    var shouldSearchBoxAppear = explorerNavStack.length === 1 ||
        (graphql_1.isType(navItem.def) && 'getFields' in navItem.def);
    var prevName;
    if (explorerNavStack.length > 1) {
        prevName = explorerNavStack[explorerNavStack.length - 2].name;
    }
    return (react_1.default.createElement("section", { className: "doc-explorer", key: navItem.name, "aria-label": "Documentation Explorer" },
        react_1.default.createElement("div", { className: "doc-explorer-title-bar" },
            prevName && (react_1.default.createElement("button", { className: "doc-explorer-back", onClick: pop, "aria-label": "Go back to " + prevName }, prevName)),
            react_1.default.createElement("div", { className: "doc-explorer-title" }, navItem.title || navItem.name),
            react_1.default.createElement("div", { className: "doc-explorer-rhs" }, children)),
        react_1.default.createElement("div", { className: "doc-explorer-contents" },
            shouldSearchBoxAppear && (react_1.default.createElement(SearchBox_1.default, { value: navItem.search, placeholder: "Search " + navItem.name + "...", onSearch: showSearch })),
            content)));
}, function (prevProps, nextProps) {
    return prevProps.schema === nextProps.schema &&
        prevProps.schemaErrors === nextProps.schemaErrors;
});
//# sourceMappingURL=DocExplorer.js.map