import { HistoryStore, QueryStoreItem, StorageAPI } from '@graphiql/toolkit';
import React, { ReactNode } from 'react';
import { HandleEditLabelFn, HandleSelectQueryFn, HandleToggleFavoriteFn } from './HistoryQuery';
declare type QueryHistoryProps = {
    onSelectQuery: HandleSelectQueryFn;
    storage: StorageAPI;
    maxHistoryLength: number;
    children?: ReactNode;
};
declare type QueryHistoryState = {
    queries: Array<QueryStoreItem>;
};
export declare class QueryHistory extends React.Component<QueryHistoryProps, QueryHistoryState> {
    historyStore: HistoryStore;
    constructor(props: QueryHistoryProps);
    onUpdateHistory: (query?: string | undefined, variables?: string | undefined, headers?: string | undefined, operationName?: string | undefined) => void;
    onHandleEditLabel: HandleEditLabelFn;
    onToggleFavorite: HandleToggleFavoriteFn;
    render(): JSX.Element;
}
export {};
//# sourceMappingURL=QueryHistory.d.ts.map